use microrm::prelude::*;
use test_log::test;

mod common;

#[derive(Entity)]
struct KV {
    #[key]
    name: String,
    value: String,
}

#[derive(Default, Schema)]
struct KVDB {
    entries: microrm::IDMap<KV>,
}

#[test]
fn repeated_uniqueness() {
    let (pool, db): (_, KVDB) = common::open_test_db!();
    let mut lease = pool.acquire().unwrap();

    db.entries
        .first()
        .first()
        .get(&mut lease)
        .expect("couldn't execute query with multiple uniqueness constraints");
}
